	list p=12f629
	#include <p12f629.inc>
	radix dec
; Compiled with: PIC Simulator IDE v6.91
; Microcontroller model: PIC12F629
; Clock frequency: 4.0 MHz
;
;       The address of 'dp' (byte) (global) is 0x2D
	dp EQU 0x2D
;       The address of 'code' (array 2) (byte) (global) is 0x2E
	code EQU 0x2E
;       The address of 'guess' (array 2) (byte) (global) is 0x30
	guess EQU 0x30
;       The address of 'xcount' (byte) (global) is 0x32
	xcount EQU 0x32
;       The address of 'state' (bit) (global) is 0x33,0
;       The address of 'oldstate' (bit) (global) is 0x33,1
;       The address of 'started' (bit) (global) is 0x33,2
;       The address of 'j' (byte) (global) is 0x34
	j EQU 0x34
;       The address of 'newcode' (array 2) (byte) (global) is 0x35
	newcode EQU 0x35
;       The address of 'ucount' (byte) (global) is 0x37
	ucount EQU 0x37
;       The address of 'ustate' (bit) (global) is 0x33,3
;       The address of 'uoldstate' (bit) (global) is 0x33,4
;       The address of 'ustarted' (bit) (global) is 0x33,5
;       The address of 'armed' (bit) (global) is 0x33,6
;       The address of 'buzzeron' (bit) (global) is 0x33,7
;       The address of 'nowalarm' (bit) (global) is 0x38,0
;       The address of 'oldalarm' (bit) (global) is 0x38,1
;       The address of 'led1out' (bit) (global) is 0x5,5
;       The address of 'buzzer' (bit) (global) is 0x5,4
;       The address of 'alarmsw' (bit) (global) is 0x5,2
;       The address of 'usersw' (bit) (global) is 0x5,1
;       The address of 'reedsw' (bit) (global) is 0x5,0
; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	ARRARG_0 EQU 0x2C
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0004
	ORG 0x0004
	RETFIE
; Begin of program
L0004:
; 1: 'Reed Safe Project
; 2: 'Jim Tarchinski
; 3: '2005-02-16
; 4: 'Uses a reed switch to input a two-digit code that
; 5: 'will unlock the safe.
; 6: 'VERSION 20 IS THE FIRST VERSION FOR THE NEW (FAB'ED) PC BOARD.
; 7: '++++++++++++++++++++++
; 8: 'config Word = $0194
; 9: '++++++++++++++++++++++
; 10: EEPROM 0, 3
; 11: EEPROM 1, 1
; 12: 
; 13: Symbol led1out = GPIO.5  'inverse logic 1=Off, 0=On
; 14: Symbol buzzer = GPIO.4  'inverse logic 1=Off, 0=Buzzing
; 15: Symbol alarmsw = GPIO.2  'Inverse logic so 0=Door closed, 1=open (Was 3 for the Proto Board.)
; 16: Symbol usersw = GPIO.1  'Inverse logic - User micro switch
; 17: Symbol reedsw = GPIO.0  'inverse logic 1=normal with no magnet, 0=magnet
; 18: 
; 19: Dim dp As Byte  'digit pointer
; 20: Dim code(2) As Byte  'The correct code (stored as constant).
; 21: Dim guess(2) As Byte  'The guessed code.
; 22: Dim xcount As Byte  'Counts the number of loops input was inactive.
; 23: Dim state As Bit  'Status of the input (reed switch) with inverse logic.
; 24: Dim oldstate As Bit
; 25: Dim started As Bit  'Flag if the process has been started.
; 26: 
; 27: Dim j As Byte  'User code enter pointer
; 28: Dim newcode(2) As Byte
; 29: Dim ucount As Byte  'Same purpose as above
; 30: Dim ustate As Bit
; 31: Dim uoldstate As Bit
; 32: Dim ustarted As Bit
; 33: 
; 34: Dim armed As Bit  'State of the alarm.
; 35: Dim buzzeron As Bit  'True is alarm should be sounding.
; 36: Dim nowalarm As Bit  'Current status of the alarm.
; 37: Dim oldalarm As Bit  'Last alarm switch state.
; 38: 
; 39: INTCON.T0IE = 0  'disenable Timer0 interrupts
	BCF 0x0B,5
; 40: INTCON.GIE = 0  'disable all un-masked interrupts
	BCF 0x0B,7
; 41: OPTION_REG.T0CS = 0  'set Timer0 clock source to internal instruction cycle clock
	BSF STATUS,RP0
	BCF 0x01,5
; 42: OPTION_REG.7 = 0  '0=enable pull up resistors!  13L1
	BCF 0x01,7
	BCF STATUS,RP0
; 43: CMCON = %11111111  'All digital I/O (REQUIRED)
	MOVLW 0xFF
	MOVWF 0x19
; 44: TRISIO = %11001111  '0=output 1=input (REQUIRED)
	MOVLW 0xCF
	BSF STATUS,RP0
	MOVWF 0x05
	BCF STATUS,RP0
; 45: OSCCAL = %11111100
	MOVLW 0xFC
	BSF STATUS,RP0
	MOVWF 0x10
	BCF STATUS,RP0
; 46: WPU = %00000111  '13L1
	MOVLW 0x07
	BSF STATUS,RP0
	MOVWF 0x15
	BCF STATUS,RP0
; 47: 
; 48: main:
L0001:
; 49: Read 0, code(0)  'Read the currently programed code.
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x2E
; 50: Read 1, code(1)
	MOVLW 0x01
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x2F
; 51: If code(0) = 0 Or code(1) = 0 Then
	MOVF 0x2E,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0007
	GOTO L0006
L0007:
	MOVF 0x2F,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0005
L0006:
; 52: 	code(0) = 3  'Must not be zero.
	MOVLW 0x03
	MOVWF 0x2E
; 53: 	code(1) = 1
	MOVLW 0x01
	MOVWF 0x2F
; 54: 	Write 0, code(0)  'Save the new code either way.
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BCF STATUS,RP0
	MOVF 0x2E,W
	BSF STATUS,RP0
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0008:	BTFSC EECON1,WR
	GOTO L0008
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 55: 	Write 1, code(1)
	MOVLW 0x01
	BSF STATUS,RP0
	MOVWF EEADR
	BCF STATUS,RP0
	MOVF 0x2F,W
	BSF STATUS,RP0
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0009:	BTFSC EECON1,WR
	GOTO L0009
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 56: Endif
L0005:
; 57: 
; 58: dp = 0
	CLRF 0x2D
; 59: started = False
	BCF 0x33,2
; 60: state = reedsw
	BTFSC 0x05,0
	BSF 0x33,0
	BTFSS 0x05,0
	BCF 0x33,0
; 61: oldstate = state
	BTFSC 0x33,0
	BSF 0x33,1
	BTFSS 0x33,0
	BCF 0x33,1
; 62: oldalarm = 1
	BSF 0x38,1
; 63: 
; 64: newcode(0) = 0
	CLRF 0x35
; 65: newcode(1) = 0
	CLRF 0x36
; 66: j = 0
	CLRF 0x34
; 67: ustarted = False
	BCF 0x33,5
; 68: ustate = reedsw
	BTFSC 0x05,0
	BSF 0x33,3
	BTFSS 0x05,0
	BCF 0x33,3
; 69: uoldstate = state
	BTFSC 0x33,0
	BSF 0x33,4
	BTFSS 0x33,0
	BCF 0x33,4
; 70: uoldstate = 1
	BSF 0x33,4
; 71: 
; 72: armed = False  'Is it armed to run alarm?
	BCF 0x33,6
; 73: buzzeron = False
	BCF 0x33,7
; 74: buzzer = 1  'off
	BSF 0x05,4
; 75: 
; 76: loop:
L0002:
; 77: '=-=-=-==-=-= TEST ONLY =-=-=-=-=-=-
; 78: 'led1out = 0
; 79: 'WaitMs 2000
; 80: 'led1out = 1
; 81: 'loop:
; 82: 'If alarmsw = 1 Then
; 83: 'led1out = reedsw
; 84: 'Else
; 85: 'led1out = 1
; 86: 'Endif
; 87: 	'buzzer = alarmsw
; 88: 'Goto loop
; 89: '=-=-=-==-=-= TEST ONLY =-=-=-=-=-=-
; 90: 
; 91: 
; 92: '====== Check Reed Switch ======================
; 93: 	state = reedsw
	BTFSC 0x05,0
	BSF 0x33,0
	BTFSS 0x05,0
	BCF 0x33,0
; 94: 	led1out = state
	BTFSC 0x33,0
	BSF 0x05,5
	BTFSS 0x33,0
	BCF 0x05,5
; 95: 	If state = 0 Then
	BTFSC 0x33,0
	GOTO L0010
; 96: 	'== Reed Switch closed ==
; 97: 		If oldstate = 1 Then
	BTFSS 0x33,1
	GOTO L0011
; 98: 		'=== Rising edge ===
; 99: 			started = True
	BSF 0x33,2
; 100: 			guess(dp) = guess(dp) + 1
	MOVF 0x2D,W
	ADDLW 0x30
	MOVWF FSR
	MOVF INDF,W
	ADDLW 0x01
	MOVWF R5L
	MOVF 0x2D,W
	ADDLW 0x30
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
; 101: 			If guess(dp) > 9 Then guess(dp) = 0
	MOVF 0x2D,W
	ADDLW 0x30
	MOVWF FSR
	MOVF INDF,W
	SUBLW 0x09
	BTFSC STATUS,C
	GOTO L0012
	MOVF 0x2D,W
	ADDLW 0x30
	MOVWF FSR
	CLRF INDF
L0012:
; 102: 			Gosub buzz
	CALL L0003
; 103: 		Endif
L0011:
; 104: 	Else
	GOTO L0013
L0010:
; 105: 	'== Reed Switch Open ==
; 106: 		If oldstate = 0 Then
	BTFSC 0x33,1
	GOTO L0014
; 107: 		'=== Falling edge ===
; 108: 			xcount = 0
	CLRF 0x32
; 109: 		Else
	GOTO L0015
L0014:
; 110: 		'=== Continued Low Level ===
; 111: 			If started = True Then xcount = xcount + 1
	BTFSS 0x33,2
	GOTO L0016
	MOVF 0x32,W
	ADDLW 0x01
	MOVWF 0x32
L0016:
; 112: 		Endif
L0015:
; 113: 	Endif
L0013:
; 114: 	oldstate = state
	BTFSC 0x33,0
	BSF 0x33,1
	BTFSS 0x33,0
	BCF 0x33,1
; 115: 
; 116: 'Now check the timer
; 117: 	If xcount = 75 Then
	MOVF 0x32,W
	SUBLW 0x4B
	BTFSS STATUS,Z
	GOTO L0017
; 118: 		Gosub buzz
	CALL L0003
; 119: 		dp = dp + 1  'Point to next digit
	MOVF 0x2D,W
	ADDLW 0x01
	MOVWF 0x2D
; 120: 		If dp = 2 Then
	MOVF 0x2D,W
	SUBLW 0x02
	BTFSS STATUS,Z
	GOTO L0018
; 121: 			If guess(0) = code(0) Then
	MOVF 0x30,W
	SUBWF 0x2E,W
	BTFSS STATUS,Z
	GOTO L0019
; 122: 				If guess(1) = code(1) Then
	MOVF 0x31,W
	SUBWF 0x2F,W
	BTFSS STATUS,Z
	GOTO L0020
; 123: 					armed = False
	BCF 0x33,6
; 124: 					buzzeron = False
	BCF 0x33,7
; 125: 					Gosub buzz
	CALL L0003
; 126: 					WaitMs 200
	MOVLW 0xC8
	MOVWF R0L
	CLRF R0H
	CALL W001
; 127: 					Gosub buzz
	CALL L0003
; 128: 				Endif
L0020:
; 129: 			Endif
L0019:
; 130: 			started = False
	BCF 0x33,2
; 131: 			xcount = 0
	CLRF 0x32
; 132: 			dp = 0  'Timed out.  User must start over!
	CLRF 0x2D
; 133: 			guess(0) = 0
	CLRF 0x30
; 134: 			guess(1) = 0
	CLRF 0x31
; 135: 		Endif
L0018:
; 136: 	Endif
L0017:
; 137: 
; 138: 
; 139: '======= Check User Input Switch ==============
; 140: 	If buzzeron = False Then  'Cannot change code if alarm is on
	BTFSC 0x33,7
	GOTO L0021
; 141: 		ustate = usersw
	BTFSC 0x05,1
	BSF 0x33,3
	BTFSS 0x05,1
	BCF 0x33,3
; 142: 		If ustate = 0 Then
	BTFSC 0x33,3
	GOTO L0022
; 143: 		'== Switch closed ==
; 144: 			If uoldstate = 1 Then
	BTFSS 0x33,4
	GOTO L0023
; 145: 			'=== Rising edge (Start of key press) ===
; 146: 				ustarted = True  'Enter new code input mode.
	BSF 0x33,5
; 147: 				newcode(j) = newcode(j) + 1  'Increment this digit
	MOVF 0x34,W
	ADDLW 0x35
	MOVWF FSR
	MOVF INDF,W
	ADDLW 0x01
	MOVWF R5L
	MOVF 0x34,W
	ADDLW 0x35
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
; 148: 				If newcode(j) > 9 Then newcode(j) = 0
	MOVF 0x34,W
	ADDLW 0x35
	MOVWF FSR
	MOVF INDF,W
	SUBLW 0x09
	BTFSC STATUS,C
	GOTO L0024
	MOVF 0x34,W
	ADDLW 0x35
	MOVWF FSR
	CLRF INDF
L0024:
; 149: 				Gosub buzz
	CALL L0003
; 150: 			Endif
L0023:
; 151: 		Else  'ustate = 1 (open)
	GOTO L0025
L0022:
; 152: 		'== Switch Open ==
; 153: 			If uoldstate = 0 Then
	BTFSC 0x33,4
	GOTO L0026
; 154: 			'=== Falling edge (was pressed now is open) ===
; 155: 				ucount = 0  'Start the timer after user opens switch last time.
	CLRF 0x37
; 156: 			Else
	GOTO L0027
L0026:
; 157: 			'=== Continued not pressed ===
; 158: 				If ustarted = True Then ucount = ucount + 1
	BTFSS 0x33,5
	GOTO L0028
	MOVF 0x37,W
	ADDLW 0x01
	MOVWF 0x37
L0028:
; 159: 			Endif
L0027:
; 160: 		Endif
L0025:
; 161: 		uoldstate = ustate
	BTFSC 0x33,3
	BSF 0x33,4
	BTFSS 0x33,3
	BCF 0x33,4
; 162: 	Endif
L0021:
; 163: 
; 164: 	If ucount = 75 Then
	MOVF 0x37,W
	SUBLW 0x4B
	BTFSS STATUS,Z
	GOTO L0029
; 165: 		Gosub buzz
	CALL L0003
; 166: 		j = j + 1  'Point to next digit
	MOVF 0x34,W
	ADDLW 0x01
	MOVWF 0x34
; 167: 		If j = 2 Then
	MOVF 0x34,W
	SUBLW 0x02
	BTFSS STATUS,Z
	GOTO L0030
; 168: 			If newcode(0) > 0 And newcode(1) > 0 Then  'Good new code entered
	MOVF 0x35,W
	SUBLW 0x00
	BTFSC STATUS,C
	GOTO L0031
	MOVF 0x36,W
	SUBLW 0x00
	BTFSC STATUS,C
	GOTO L0031
; 169: 				code(0) = newcode(0)
	MOVF 0x35,W
	MOVWF 0x2E
; 170: 				code(1) = newcode(1)
	MOVF 0x36,W
	MOVWF 0x2F
; 171: 				Write 0, code(0)
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BCF STATUS,RP0
	MOVF 0x2E,W
	BSF STATUS,RP0
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0032:	BTFSC EECON1,WR
	GOTO L0032
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 172: 				Write 1, code(1)
	MOVLW 0x01
	BSF STATUS,RP0
	MOVWF EEADR
	BCF STATUS,RP0
	MOVF 0x2F,W
	BSF STATUS,RP0
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0033:	BTFSC EECON1,WR
	GOTO L0033
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 173: 				led1out = 0  'Blink light when done
	BCF 0x05,5
; 174: 				Gosub buzz
	CALL L0003
; 175: 				WaitMs 50
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
; 176: 				Gosub buzz
	CALL L0003
; 177: 				led1out = 1  'Light back off
	BSF 0x05,5
; 178: 				ustarted = False
	BCF 0x33,5
; 179: 				ucount = 0
	CLRF 0x37
; 180: 				j = 0  'Timed out.  User must start over!
	CLRF 0x34
; 181: 				newcode(0) = 0
	CLRF 0x35
; 182: 				newcode(1) = 0
	CLRF 0x36
; 183: 			Else  'Bad code entered
	GOTO L0034
L0031:
; 184: 				Gosub buzz
	CALL L0003
; 185: 				Gosub buzz
	CALL L0003
; 186: 				Gosub buzz
	CALL L0003
; 187: 				ustarted = False
	BCF 0x33,5
; 188: 				ucount = 0
	CLRF 0x37
; 189: 				j = 0  'Timed out.  User must start over!
	CLRF 0x34
; 190: 				newcode(0) = 0
	CLRF 0x35
; 191: 				newcode(1) = 0
	CLRF 0x36
; 192: 			Endif
L0034:
; 193: 		Endif
L0030:
; 194: 	Endif
L0029:
; 195: 
; 196: 
; 197: 	'=== HANDLE THE ALARM SWITCH ===
; 198: 	nowalarm = alarmsw
	BTFSC 0x05,2
	BSF 0x38,0
	BTFSS 0x05,2
	BCF 0x38,0
; 199: 	If nowalarm = 0 Then
	BTFSC 0x38,0
	GOTO L0035
; 200: 		If oldalarm = 1 Then  'Edge triggered
	BTFSS 0x38,1
	GOTO L0036
; 201: 			If armed = True Then
	BTFSS 0x33,6
	GOTO L0037
; 202: 				buzzeron = True  'set the flag
	BSF 0x33,7
; 203: 				buzzer = 0  'turn on the actual buzzer
	BCF 0x05,4
; 204: 			Else
	GOTO L0038
L0037:
; 205: 				armed = True
	BSF 0x33,6
; 206: 			Endif
L0038:
; 207: 			started = False
	BCF 0x33,2
; 208: 			xcount = 0
	CLRF 0x32
; 209: 			dp = 0  'user must start over!
	CLRF 0x2D
; 210: 			guess(0) = 0
	CLRF 0x30
; 211: 			guess(1) = 0
	CLRF 0x31
; 212: 		Endif
L0036:
; 213: 	Endif
L0035:
; 214: 	oldalarm = nowalarm
	BTFSC 0x38,0
	BSF 0x38,1
	BTFSS 0x38,0
	BCF 0x38,1
; 215: 
; 216: 	WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 217: 
; 218: Goto loop
	GOTO L0002
; 219: 
; 220: End
L0039:	GOTO L0039
; 221: 
; 222: 
; 223: buzz:
L0003:
; 224: 	If buzzeron = False Then
	BTFSC 0x33,7
	GOTO L0040
; 225: 		buzzer = 0
	BCF 0x05,4
; 226: 		WaitMs 50
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
; 227: 		buzzer = 1
	BSF 0x05,4
; 228: 	Else
	GOTO L0041
L0040:
; 229: 		buzzer = 1
	BSF 0x05,4
; 230: 		WaitMs 50
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
; 231: 		buzzer = 0
	BCF 0x05,4
; 232: 	Endif
L0041:
; 233: Return
	RETURN
; End of program
L0042:	GOTO L0042
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:
	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x12
	MOVWF R1L
W005:
	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:
	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:
	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; EEPROM data
	ORG 0x2100
	DW 0x03
	DW 0x01
; End of listing
	END
